#include <stdio.h>
#include <stdlib.h>

#include "tables.h"

int read_id3(FILE *in)
{
char tag[32];
int ch,t;

  for (t=0; t<30; t++)
  {
    ch=getc(in);
    tag[t]=ch;
  }
  tag[t]=0;
  printf("   Title: %s\n",tag);

  for (t=0; t<30; t++)
  {
    ch=getc(in);
    tag[t]=ch;
  }
  tag[t]=0;
  printf("  Artist: %s\n",tag);

  for (t=0; t<30; t++)
  {
    ch=getc(in);
    tag[t]=ch;
  }
  tag[t]=0;
  printf("   Album: %s\n",tag);

  for (t=0; t<4; t++)
  {
    ch=getc(in);
    tag[t]=ch;
  }
  tag[t]=0;
  printf("    Year: %s\n",tag);

  for (t=0; t<30; t++)
  {
    ch=getc(in);
    tag[t]=ch;
  }
  tag[t]=0;
  printf("Comments: %s\n",tag);

  ch=getc(in);
  printf("   Genre: %s\n",genre[ch]);

}

int anal_mp3(char *filename)
{
FILE *in;
char tag[4];
int ch,t,lay,bitrate_index,version;
int samp_freq;
int id3;

  id3=-1;

  in=fopen(filename,"r");
  if (in==0) return -3;

  printf("\n");

/* Check for Sync */

  while(1)
  {
    ch=getc(in);
    if (ch==EOF) return -1;

    if (ch==0xff)
    {
      ch=getc(in);
      if (ch==EOF) return -1;
      if ((ch&0xf0)==0xf0) break;
    }
      else
    if (ch=='I')
    {
      ch=getc(in);
      if (ch!='D')
      {
        ungetc(ch,in);
        continue;
      }

      ch=getc(in);
      if (ch!='3')
      {
        ungetc(ch,in);
        continue;
      }

      id3=ftell(in)-3;
    }
  }
  
  printf("         Version: ");
  /* ch=getc(in); */
  if ((ch&8)==0)
  {
    printf("mpeg 2.0\n"); 
    version=2;
  }
    else
  {
    printf("mpeg 1.0\n");
    version=1;
  }

  lay=(ch&6)>>1;
  lay=4-lay;
  printf("           Layer: ");

  if (lay==1)
  { printf("I\n"); }
    else
  if (lay==2)
  { printf("II\n"); }
    else
  if (lay==3)
  { printf("III\n"); }
    else
  if (lay==0)
  { printf("error\n"); }

  printf("Error Protection: ");

  if ((ch&1)==1)
  { printf("no\n"); }
    else
  { printf("yes\n"); }

  ch=getc(in);
  printf("        Bit Rate: ");
  bitrate_index=ch>>4;

  if (version==1)
  {
    printf("%d\n",bitrate_mpeg1[(lay-1)*14+(bitrate_index-1)]);
  }
    else
  {
    printf("%d\n",bitrate_mpeg2[(lay-1)*14+(bitrate_index-1)]);
  }

  printf("   Sampling Freq: ");
  samp_freq=(ch>>2)&3;

  if (version==1)
  {
    printf("%d\n",samp_freq_mpeg1[samp_freq]);
  }
    else
  {
    printf("%d\n",samp_freq_mpeg2[samp_freq]);
  }

  printf("         Padding: %d\n",((ch&2)>>1));
  printf("       Extension: %d\n",(ch&1));

  ch=getc(in);

  printf("            Mode: ");
  t=ch>>6;

  if (t==0)
  { printf("stereo\n"); }
    else
  if (t==1)
  { printf("joint stereo\n"); }
    else
  if (t==2)
  { printf("dual channel\n"); }
    else
  { printf("single channel\n"); }

  if (t==1)
  {
    printf("        Mode_ext: ");
    t=(ch>>6)&3;

    if (t==0)
    { printf("MPG_MD_LR_LR\n"); }
      else
    if (t==1)
    { printf("MPG_MD_LR_I\n"); }
      else
    if (t==2)
    { printf("MPG_MD_MS_LR\n"); }
      else
    { printf("MPG_MD_MS_I\n"); }

    printf("         jsbound: %d\n",jsbound[(lay-1)*4+t]);
  }

  printf("       Copyright: ");
  if ((ch&8)==0)
  { printf("No\n"); }
    else
  { printf("Yes\n"); }

  printf("        Original: ");

  if ((ch&4)==0)
  { printf("No\n"); }
    else
  { printf("Yes\n"); }

  printf("        Emphasis: ");
  t=ch&3;

  if (t==0)
  { printf("none\n"); }
    else
  if (t==1)
  { printf("50/15 microsecs\n"); }
    else
  if (t==2)
  { printf("reserved\n"); }
    else
  if (t==3)
  { printf("CCITT J 17\n"); }

/* 
   Move to the end of the file and then rewind 128 bytes 
   to look for the ID3 TAG This contains just the song 
   name and stuff
*/

  if (id3==-1)
  { fseek(in,-128,SEEK_END); }
    else
  { fseek(in,id3,SEEK_SET); }

  for (t=0; t<3; t++)
  {
    ch=getc(in);
    tag[t]=ch;
  }
  tag[t]=0;

  printf("\n");

  if (strcmp("TAG",tag)==0 || strcmp("ID3",tag)==0)
  { read_id3(in); }

  printf("\n");

  fclose(in);

  return 0;
}

main(int argc, char *argv[])
{
char filename[1024];

  if (argc!=2)
  {
    printf("Usage: anal_mp3 <input filename>\n\n");
    exit(0);
  }

  printf("\n------------------------------------------\n");
  printf("Anal MP3 V1.0 - By Michael Kohn\n");
  printf("------------------------------------------\n");

  strcpy(filename,argv[1]);

  anal_mp3(filename);

}

