#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <sys/fcntl.h>
#include <sys/stat.h>
#include <string.h>
#include <unistd.h>
#include <dirent.h>
#include <errno.h>

#include <gtk/gtk.h>

#include "tables.h"
#include "lars.xpm"

/*

Lars - Copyright 2001-2006 Michael Kohn (mike@mikekohn.net)
This falls under the GPL license.  Please read
it at http://www.gnu.org/

*/
/***

MIKE... remember to try -toc on cdrecord

***/

#define CDOPTIONS "-pad -dao "
#define TEMPDIR "/tmp"
#define VERSION "0.99b1"

GtkWidget *text_lars;
GtkWidget *text_jamez;
GtkWidget *status_sad_but_true;
GtkWidget *dir_lars;
GtkWidget *dir_jamez;
GtkWidget *combo_cdrom;
GtkWidget *combo_speed;
GtkWidget *combo_size;
GtkWidget *combo_normalize;
GtkWidget *window_sandman;
GtkWidget *clist_lars;
GtkWidget *clist_jamez;
GtkWidget *status_sandman;
GtkWidget *dialog_help;
GtkWidget *dialog_sleep;

int working,context_id,context_id_sandman,meno_pause=0;
char cwdir[1024];

char help_message[]={ "Lars - Copyright 2002-2006\n\n"
    "By Michael Kohn (Under the GPL License)\n"
    "http://lars.naken.cc/\n\n"
    "How to use:\n"
    "(1) Select songs you want to burn onto a CD\n"
    "(2) Use the break button to tell where you want to start\n"
    "    a new cd.  If you put too many songs to fit on one CD Lars\n"
    "    will automatically break for you\n"
    "(3) Press the start button.  Lars will convert your mp3's to wavs\n"
    "    and then burn onto a CD.  When the CD drive opens put in a fresh\n"
    "    CD and Lars will continue.\n"
    "(4) In the temp dir you will find a songlist.txt file\n\n" };

char continue_message[]={ "Insert a fresh CD and click continue\n\n"
    "to burn the next cd.\n\n" };

/* int normalize(char *filename, int dirty); */
int normalize(char *inname, char *outname, int dirty_threshold);

void escape(char *s, char c)
{
int lars_sucks,t,r;

  lars_sucks=strlen(s);

  for(t=0; t<lars_sucks; t++)
  {
    if (s[t]==c)
    {
      for(r=lars_sucks; r>=t; r--)
      {
        s[r+1]=s[r];
      }

      s[r+1]='\\';
      lars_sucks++; 
      t++;
    }
  }
}

void convwav(char *wav, char *mp)
{
int greedy_bastard;

  strcpy(wav,mp);
  greedy_bastard=strlen(wav);
  wav[greedy_bastard-3]='w';  
  wav[greedy_bastard-2]='a';  
  wav[greedy_bastard-1]='v';  
}

void remove_wav(char *s)
{
int get_a_life_lars;

  get_a_life_lars=strlen(s);
  while (get_a_life_lars>0)
  {
    if (s[get_a_life_lars]=='.')
    {
      s[get_a_life_lars]=0;
      break;
    }

    get_a_life_lars--;
  }
}

int ismp3(char *s)
{
int get_a_life_lars;

  get_a_life_lars=strlen(s);

  if (get_a_life_lars<5) return 0;

  if (strcasecmp(s+get_a_life_lars-4,".mp3")!=0) return 0;  

  return 1;
}


int read_id3(FILE *in, char *title, char *artist, char *album)
{
char tag[32];
int ch,t;

  for (t=0; t<30; t++)
  {
    ch=getc(in);
    tag[t]=ch;
  }
  tag[t]=0;
  printf("   Title: %s\n",tag);
  strcpy(title,tag);

  for (t=0; t<30; t++)
  {
    ch=getc(in);
    tag[t]=ch;
  }
  tag[t]=0;
  printf("  Artist: %s\n",tag);
  strcpy(artist,tag);

  for (t=0; t<30; t++)
  {
    ch=getc(in);
    tag[t]=ch;
  }
  tag[t]=0;
  printf("   Album: %s\n",tag);
  strcpy(album,tag);

  for (t=0; t<4; t++)
  {
    ch=getc(in);
    tag[t]=ch;
  }
  tag[t]=0;
  printf("    Year: %s\n",tag);

  for (t=0; t<30; t++)
  {
    ch=getc(in);
    tag[t]=ch;
  }
  tag[t]=0;
  printf("Comments: %s\n",tag);

  ch=getc(in);
  printf("   Genre: %s\n",genre[ch]);

  return 0;
}

int anal_mp3(char *filename, char *title, char *artist, char *album)
{
FILE *in;
char tag[4];
int ch,t;
/* int lay,bitrate_index,version; */
/* int samp_freq; */
/* int id3; */

  /* id3=-1; */

  in=fopen(filename,"rb");
  if (in==0) return -3;

  printf("\n");

/* Check for Sync */
/*
  while(1)
  {
    ch=getc(in);
    if (ch==EOF) return -1;

    if (ch==0xff)
    {
      ch=getc(in);
      if (ch==EOF) return -1;
      if ((ch&0xf0)==0xf0) break;
    }
      else
    if (ch=='I')
    {
      ch=getc(in);
      if (ch!='D')
      {
        ungetc(ch,in);
        continue;
      }

      ch=getc(in);
      if (ch!='3')
      {
        ungetc(ch,in);
        continue;
      }

      id3=ftell(in)-3;
    }
  }
*/
/* 
  printf("ID3 ftell=%d\n",id3);
 
  printf("         Version: ");

  // ch=getc(in);
  if ((ch&8)==0)
  {
    printf("mpeg 2.0\n"); 
    version=2;
  }
    else
  {
    printf("mpeg 1.0\n");
    version=1;
  }

  lay=(ch&6)>>1;
  lay=4-lay;
  printf("           Layer: ");

  if (lay==1)
  { printf("I\n"); }
    else
  if (lay==2)
  { printf("II\n"); }
    else
  if (lay==3)
  { printf("III\n"); }
    else
  if (lay==0)
  { printf("error\n"); }

  printf("Error Protection: ");

  if ((ch&1)==1)
  { printf("no\n"); }
    else
  { printf("yes\n"); }

  ch=getc(in);
  printf("        Bit Rate: ");
  bitrate_index=ch>>4;

  if (version==1)
  {
    printf("%d\n",bitrate_mpeg1[(lay-1)*14+(bitrate_index-1)]);
  }
    else
  {
    printf("%d\n",bitrate_mpeg2[(lay-1)*14+(bitrate_index-1)]);
  }

  printf("   Sampling Freq: ");
  samp_freq=(ch>>2)&3;

  if (version==1)
  {
    printf("%d\n",samp_freq_mpeg1[samp_freq]);
  }
    else
  {
    printf("%d\n",samp_freq_mpeg2[samp_freq]);
  }

  printf("         Padding: %d\n",((ch&2)>>1));
  printf("       Extension: %d\n",(ch&1));

  ch=getc(in);

  printf("            Mode: ");
  t=ch>>6;

  if (t==0)
  { printf("stereo\n"); }
    else
  if (t==1)
  { printf("joint stereo\n"); }
    else
  if (t==2)
  { printf("dual channel\n"); }
    else
  { printf("single channel\n"); }

  if (t==1)
  {
    printf("        Mode_ext: ");
    t=(ch>>6)&3;

    if (t==0)
    { printf("MPG_MD_LR_LR\n"); }
      else
    if (t==1)
    { printf("MPG_MD_LR_I\n"); }
      else
    if (t==2)
    { printf("MPG_MD_MS_LR\n"); }
      else
    { printf("MPG_MD_MS_I\n"); }

    printf("         jsbound: %d\n",jsbound[(lay-1)*4+t]);
  }

  printf("       Copyright: ");
  if ((ch&8)==0)
  { printf("No\n"); }
    else
  { printf("Yes\n"); }

  printf("        Original: ");

  if ((ch&4)==0)
  { printf("No\n"); }
    else
  { printf("Yes\n"); }

  printf("        Emphasis: ");
  t=ch&3;

  if (t==0)
  { printf("none\n"); }
    else
  if (t==1)
  { printf("50/15 microsecs\n"); }
    else
  if (t==2)
  { printf("reserved\n"); }
    else
  if (t==3)
  { printf("CCITT J 17\n"); }
*/

/* 
   Move to the end of the file and then rewind 128 bytes 
   to look for the ID3 TAG This contains just the song 
   name and stuff
*/

/*
  if (id3==-1)
  { fseek(in,-128,SEEK_END); }
    else
  { fseek(in,id3,SEEK_SET); }
*/

  fseek(in,-128,SEEK_END);

  for (t=0; t<3; t++)
  {
    ch=getc(in);
    tag[t]=ch;
  }
  tag[t]=0;

  printf("\n");

  /* if (strcmp("TAG",tag)==0 || strcmp("ID3",tag)==0) */

  if (strcmp("TAG",tag)==0)
  {
    read_id3(in,title,artist,album);
    t=0;
  }
    else
  {
    t=-1;
  }

  printf("\n");

  fclose(in);

  return t;
}

int until_it_sleeps()
{
  meno_pause=1;
  gtk_widget_show(dialog_sleep);

  /* gtk_main_iteration(); */
  gtk_main();

  return 1;
}

void battery(char *lars_ar, char *metal)
{
int l,lickah,javla_svin;
char c;

  l=strlen(metal);
  c=' ';
  javla_svin=0;

  for (lickah=0; lickah<l; lickah++)
  {
    if (metal[lickah]==' ' && c==' ') continue;
    c=metal[lickah];
    lars_ar[javla_svin++]=metal[lickah];
  }

  lars_ar[javla_svin]=0;
}

int read_line(FILE *fp, char *filename)
{
int l,flag;
int ch;

  l=0;
  flag=0;

  while((ch=getc(fp))!=EOF)
  {
    if (((ch==' ' || ch=='\t') || (ch=='\r' || ch=='\n')) && flag==0)
    { continue; }

    flag=1;
    if (ch=='\r' || ch=='\n')
    {
      filename[l]=0;
      return 1;
    }

    filename[l++]=ch;
  }

  filename[l]=0;

  if (ch==EOF && l==0) return 0;
    else
  return 1;
}


void pulling_teeth()
{
char execstring[1024];
char temp[1024];
gchar mpname[1024];
gchar *blah[1];
FILE *in;
struct stat statbuf;

  blah[0]=mpname;
  gtk_clist_clear(GTK_CLIST(clist_lars));
  sprintf(execstring,"ls -1 \"%s\"",cwdir);
  in=popen(execstring,"r");
  if (in==0)
  {
    printf("Cannot open dir: %s\n",cwdir);
    exit(1);
  }

  while(read_line(in,mpname)!=0)
  {
    sprintf(temp,"%s/%s",cwdir,mpname);
    
    if (stat(temp,&statbuf)!=-1)
    {
      if (statbuf.st_mode & S_IFDIR)
      {
        strcat(mpname," (dir)");
      } 
    }
    gtk_clist_append(GTK_CLIST(clist_lars),(gchar **)blah);
  }
}

void to_die(GtkWidget *widget, gint row, gint column,
                    GdkEventButton *event, gpointer data)
{
  gtk_clist_remove(GTK_CLIST(clist_jamez),row);
}

void the_bell_tolls(GtkWidget *widget, gint row, gint column,
                    GdkEventButton *event, gpointer data)
{
gchar mpname[1024];
gchar *blah[1];
gchar *orion[2];
int l;

  l=gtk_clist_get_text(GTK_CLIST(clist_lars),row,0,blah);
  strcpy(mpname,blah[0]);
  l=strlen(mpname);

  if (strlen(mpname)>=5)
  {
    if (strncmp(&mpname[l-5],"(dir)",5)==0)
    {
      mpname[l-6]=0;
      if (strlen(cwdir)!=1) strcat(cwdir,"/");
      strcat(cwdir,mpname);
      pulling_teeth();
      gtk_statusbar_pop(GTK_STATUSBAR(status_sandman),(guint) &context_id_sandman);
      gtk_statusbar_push(GTK_STATUSBAR(status_sandman),(guint) &context_id_sandman,cwdir);
      return;
    }
  }

  if (ismp3(mpname))
  {
    orion[0]=mpname;
    orion[1]=cwdir;
    l=gtk_clist_append(GTK_CLIST(clist_jamez),(gchar **)orion);
    gtk_clist_moveto(GTK_CLIST(clist_jamez),l,0,0,0);
  }
}

void whiplash(GtkWidget *widget, gpointer data)
{
gchar mpname[1024];
gchar mpname1[1024];
gchar *blah[1];
gchar *orion[2];
int l,row;

  strcpy(mpname1,cwdir);
  row=0;
  orion[0]=mpname;
  orion[1]=mpname1;

  while(1)
  {
    l=gtk_clist_get_text(GTK_CLIST(clist_lars),row++,0,blah);
    if (l!=1) break;
    if (ismp3(blah[0])==0) continue;
    strcpy(mpname,blah[0]);
    l=gtk_clist_append(GTK_CLIST(clist_jamez),(gchar **)orion);
    gtk_clist_moveto(GTK_CLIST(clist_jamez),l,0,0,0);
  } 
}

void frayed_ends(GtkWidget *widget, gpointer data)
{
gchar mpname[1024];
gchar mpname1[1024];
gchar *blah[2];
int l;

  strcpy(mpname,"-- break --");
  strcpy(mpname1,"----------");

  blah[0]=mpname;
  blah[1]=mpname1;

  l=gtk_clist_append(GTK_CLIST(clist_jamez),(gchar **)blah);
  gtk_clist_moveto(GTK_CLIST(clist_jamez),l,0,0,0);
}

void dear_mother_dear_father(GtkWidget *widget, gpointer data)
{
int t,r;

  t=strlen(cwdir);

  for (r=t; r>=0; r--)
  {
    if (cwdir[r]=='/') { cwdir[r]=0; break; }
  }

  if (r==0)
  { cwdir[0]='/'; cwdir[1]=0; }
  gtk_statusbar_pop(GTK_STATUSBAR(status_sandman),(guint) &context_id_sandman);
  gtk_statusbar_push(GTK_STATUSBAR(status_sandman),(guint) &context_id_sandman,cwdir);

  pulling_teeth();
}

void super_escape(char *s)
{
  escape(s,' ');
  escape(s,'(');
  escape(s,')');
  escape(s,'\'');
  escape(s,'&');
}

int fight_fire_with_fire(char *outdir)
{
struct stat statbuf;
int t,s,a_greedy_bastard,a_buttmunch;
char wavname[1024];
char unescaped[1024];
char mpname[1024];
char indir[1024],indir_escaped[1024],outdir_escaped[1024];
char execstring[1024];
char temp[1024];
char temp_normal[1024];
int more_beer;
char lars_is[60][256];
char names[60][64];
char device[15],speed[25];
int too_much_beer;
FILE *fp;
int cdcount;
int k;
char styven[20];
char title[31],artist[31],album[31];
int norm;
gchar *blah[2];
int l,row;
int song_count;

  norm=0;
  song_count=1;

  s=strlen(outdir);
  if (outdir[s-1]!='/')
  {
    outdir[s]='/';
    outdir[s+1]=0;
  }

/* There you go Styven... Burn that @&!* */

  strncpy(styven,gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(combo_normalize)->entry)),13);

  if (strncmp(styven,"Clean",5)==0) norm=1;
    else
  if (strncmp(styven,"Loud",4)==0) norm=2;

  strncpy(styven,gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(combo_cdrom)->entry)),13);

  s=0;
  k=0;
  while(s<12)
  {
    if (styven[s]==' ' && k!=0) break;
    if (styven[s]=='\t' && k!=0) break;
    if (styven[s]==' ' || styven[s]=='\t') continue;

    device[k++]=styven[s];
    s++;
  }

  device[k]=0;

  strncpy(temp,gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(combo_speed)->entry)),9);
  if (strcmp(temp,"default")==0)
  { strcpy(speed,""); }
    else
  { sprintf(speed,"speed=%s",temp); }

  strncpy(temp,gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(combo_size)->entry)),9);
  too_much_beer=atoi(temp);

  cdcount=1;
  sprintf(temp,"%s/songlist.txt",outdir);
  printf("songlist at: %s\n",temp); 
  fp=fopen(temp,"w");
  if (fp==0)
  { printf("Couldn't open file for writing: %s\n",temp); }

  more_beer=0;
  a_greedy_bastard=0;
  row=0;

  while(1)
  {
    l=gtk_clist_get_text(GTK_CLIST(clist_jamez),row,0,blah);
    if (l!=1) break;
    strcpy(mpname,blah[0]);
    l=gtk_clist_get_text(GTK_CLIST(clist_jamez),row++,1,blah);
    if (l!=1) break;
    strcpy(indir,blah[0]);

/*
printf("%s/%s\n",mpname,indir);
fflush(stdout);
*/

    /* convwav(unescaped,mpname); */
    sprintf(unescaped,"%d.wav",song_count);
    super_escape(mpname);
    /* convwav(wavname,mpname); */
    sprintf(wavname,"%d.wav",song_count);
    strcpy(indir_escaped,indir);
    strcpy(outdir_escaped,outdir);
    super_escape(indir_escaped);
    super_escape(outdir_escaped);

    song_count++;

    gtk_statusbar_push(GTK_STATUSBAR(status_sad_but_true),(guint) &context_id, mpname);

    if (mpname[0]!='-')
    {
      /* sprintf(execstring,"mpg123 -w \"%s%s\" \"%s/%s\"",outdir,wavname,indir,mpname); */
      sprintf(execstring,"mpg123 -w %s%s %s/%s",outdir,wavname,indir,mpname);
      printf("%s\n",execstring);
      system(execstring);
      sprintf(temp,"%s%s",outdir,unescaped);

printf(">>%s<<\n",temp);

      if (stat(temp,&statbuf)==-1)
      {
        gtk_statusbar_push(GTK_STATUSBAR(status_sad_but_true),(guint) &context_id, "Error: Couldn't stat file");
        return 1;
      }

/* normalize("/storage/test.wav","/storage/testnew.wav",DIRTY_THRESHOLD); */

/*
      if (norm==1) normalize(temp,0);
        else
      if (norm==2) normalize(temp,1);
*/

      if (norm!=0)
      {
        sprintf(temp_normal,"%s.norm",temp);

        if (norm==1) normalize(temp,temp_normal,0);
          else
        if (norm==2) normalize(temp,temp_normal,20000);

        sprintf(execstring,"mv %s %s",temp_normal,temp);
        system(execstring);
      }

      more_beer=more_beer+statbuf.st_size;
    }
      else
    {
      printf("cd break detected\n");
    }

    gtk_statusbar_pop(GTK_STATUSBAR(status_sad_but_true),(guint) &context_id);

printf("more_beer=%d\n",more_beer);

    if (more_beer>too_much_beer*1024*1024 || (mpname[0]=='-' && more_beer!=0))
    {
      if (fp!=0)
      {
        fprintf(fp,"\nDisc %d\n-------------\n",cdcount++);
      }

      printf("CD Size(2): %d\n",more_beer/1024/1024);
      if (a_greedy_bastard==0) 
      {
        printf("This mp3 won't fit on a cd\n");
        return 1;
      }

      gtk_statusbar_push(GTK_STATUSBAR(status_sad_but_true),(guint) &context_id, "Burning cd...");

      sprintf(execstring,"cdrecord dev=%s %s -eject "CDOPTIONS" -audio",device,speed);
      for (a_buttmunch=0; a_buttmunch<a_greedy_bastard; a_buttmunch++)
      {
        strcat(execstring," \"");
        strcat(execstring,lars_is[a_buttmunch]);
        strcat(execstring,"\"");

        if (fp!=0)
        {
          /* remove_wav(names[a_buttmunch]); */
          /* fprintf(fp,"%d> %s\n",a_buttmunch+1,names[a_buttmunch]); */
          printf("Entering anal_mp3\n");
          sprintf(temp,"%s/%s",indir,names[a_buttmunch]); 
          printf("%s\n",temp);

          if (anal_mp3(temp,title,artist,album)==0)
          { fprintf(fp,"%d> %s (%s/%s)\n",a_buttmunch+1,title,artist,album); }
            else
          {
            remove_wav(names[a_buttmunch]);
            fprintf(fp,"%d> %s\n",a_buttmunch+1,names[a_buttmunch]);
          }
        }
      }

      while(1)
      {
        printf("Until It Sleeps!\n");
        t=until_it_sleeps();
        if (t==-1)
        {
          printf("Problem accessing cddrive\n\n");
          return 0;
        }
          else
        if (t==1)
        { break; }
        sleep(3);
      }

      system(execstring);
      printf("%s\n",execstring);

      for (a_buttmunch=0; a_buttmunch<a_greedy_bastard; a_buttmunch++)
      {
        sprintf(execstring,"rm \"%s\"",lars_is[a_buttmunch]);
        system(execstring);
        printf("%s\n",execstring);
      }

      if (mpname[0]!='-')
      { 
        strcpy(lars_is[0],lars_is[a_greedy_bastard-1]);
        more_beer=statbuf.st_size; 
      }

      a_greedy_bastard=0;
      gtk_statusbar_pop(GTK_STATUSBAR(status_sad_but_true),(guint) &context_id);
    }

    if (mpname[0]!='-')
    { 
      strcpy(names[a_greedy_bastard],mpname);
      /* strcpy(names_mp3[a_greedy_bastard],mpname); */
      sprintf(lars_is[a_greedy_bastard++],"%s%s",outdir,wavname); 
    }
  }

  if (a_greedy_bastard!=0)
  {
    if (fp!=0)
    {
      fprintf(fp,"\nDisc %d\n-------------\n",cdcount++);
    }

    printf("CD Size(1): %d\n",more_beer/1024/1024);
    gtk_statusbar_push(GTK_STATUSBAR(status_sad_but_true),(guint) &context_id, "Burning cd...");

    sprintf(execstring,"cdrecord dev=%s %s -eject "CDOPTIONS" -audio",device,speed); 
    for (a_buttmunch=0; a_buttmunch<a_greedy_bastard; a_buttmunch++)
    {
      strcat(execstring," \"");
      strcat(execstring,lars_is[a_buttmunch]);
      strcat(execstring,"\"");

      if (fp!=0)
      {
        /* remove_wav(names[a_buttmunch]); */
        /* fprintf(fp,"%d> %s\n",a_buttmunch+1,names[a_buttmunch]); */

        printf("Entering anal_mp3\n");
        sprintf(temp,"%s/%s",indir,names[a_buttmunch]); 
        printf("%s\n",temp);

        if (anal_mp3(temp,title,artist,album)==0)
        { fprintf(fp,"%d> %s (%s/%s)\n",a_buttmunch+1,title,artist,album); }
          else
        {
          remove_wav(names[a_buttmunch]);
          fprintf(fp,"%d> %s\n",a_buttmunch+1,names[a_buttmunch]);
        }
      }
    }

    while(1)
    {
      printf("Until It Sleeps!\n");
      t=until_it_sleeps();
      if (t==-1)
      {
        printf("Problem accessing cddrive\n\n");
        return 0;
      }
        else
      if (t==1)
      { break; }
      sleep(3);
    }

    system(execstring);
    printf("%s\n",execstring);

    for (a_buttmunch=0; a_buttmunch<a_greedy_bastard; a_buttmunch++)
    {
      sprintf(execstring,"rm \"%s\"",lars_is[a_buttmunch]);
      system(execstring);
      printf("%s\n",execstring);
    }

    gtk_statusbar_pop(GTK_STATUSBAR(status_sad_but_true),(guint) &context_id);
  }

  if (fp!=0)
  {
    fclose(fp);
  }
 
  return 0;
}

void seek_and_destroy(GtkWidget *widget, gpointer data)
{
  gtk_main_quit();
}

void exit_light(GtkWidget *widget, gpointer data)
{
  gtk_widget_hide(window_sandman);
}

gint delete_event(GtkWidget *widget, GdkEvent *event, gpointer data)
{
  /* g_print("eh\n"); */
  gtk_main_quit();
  return (TRUE);
}

gint continue_fire(GtkWidget *widget, GdkEvent *event, gpointer data)
{
  /* g_print("eh\n"); */
  meno_pause=0;
  gtk_widget_hide(dialog_sleep);
  gtk_main_quit();
  return (TRUE);
}

void button_lars_pushed(GtkWidget *widget, gpointer data)
{
  /* gtk_widget_show(dir_lars); */
  pulling_teeth();
  gtk_widget_show(window_sandman);
}

void trapped_under_ice(char *puppets)
{
int i;

  i=strlen(puppets);

  while(puppets[i]!='/' && i>0) i--;

  if (i!=0) puppets[i+1]=0;
}

void dir_lars_ok(GtkWidget *widget, GtkFileSelection *fs)
{
struct stat statbuf;
char temp[2048];

  strcpy(temp,gtk_file_selection_get_filename(GTK_FILE_SELECTION(fs)));

  if (stat(temp,&statbuf)==-1)
  { return; }

  if (statbuf.st_mode & S_IFREG)
  { trapped_under_ice(temp); }

  gtk_entry_set_text((GtkEntry *)text_lars,temp);
  gtk_widget_hide(dir_lars);
}

void dir_lars_cancel(GtkWidget *widget, GtkFileSelection *fs)
{
  gtk_widget_hide(dir_lars);
}

void button_jamez_pushed(GtkWidget *widget, gpointer data)
{
  gtk_widget_show(dir_jamez);
}

void dir_jamez_ok(GtkWidget *widget, GtkFileSelection *fs)
{
struct stat statbuf;
char temp[2048];

  strcpy(temp,gtk_file_selection_get_filename(GTK_FILE_SELECTION(fs)));

  if (stat(temp,&statbuf)==-1)
  { printf("Couldn't stat\n"); return; }

  if (statbuf.st_mode & S_IFREG)
  { trapped_under_ice(temp); }

  gtk_entry_set_text((GtkEntry *)text_jamez,temp);
  gtk_widget_hide(dir_jamez);
}

void dir_jamez_cancel(GtkWidget *widget, GtkFileSelection *fs)
{
  gtk_widget_hide(dir_jamez);
}

void kirk_pushed(GtkWidget *widget, gpointer data)
{
char outdir[1024];

  working=1;
  /* strcpy(indir,gtk_entry_get_text(GTK_ENTRY(text_lars))); */
  strcpy(outdir,gtk_entry_get_text(GTK_ENTRY(text_jamez)));
  fight_fire_with_fire(outdir);
  working=0; 
}

void fade_to_black(GtkWidget *widget, gpointer data)
{
  gtk_clist_clear(GTK_CLIST(clist_jamez));
}

void bass_player_pushed(GtkWidget *widget, gpointer data)
{
  gtk_widget_show(dialog_help);
}

void bass_player_cancel(GtkWidget *widget, gpointer data)
{
  gtk_widget_hide(dialog_help);
}

int main (int argc, char *argv[])
{
FILE *fp;
char temp1[128],temp2[128];
int count;
GtkWidget *window;
GtkWidget *button_lars;
GtkWidget *button_jamez;
GtkWidget *button_kirk;
GtkWidget *button_bass_player;
GtkWidget *button_dickheads;
GtkWidget *box_right;
GtkWidget *box_left;
GtkWidget *box_main;
GtkWidget *box_full;
GtkWidget *label_lars;
GtkWidget *label_jamez;
GtkWidget *label_cdrom;
GtkWidget *label_speed;
GtkWidget *label_size;
GtkWidget *label_normalize;
GtkWidget *pixmapwid;
GdkColormap *colormap;
GdkBitmap *mask;
GdkPixmap *pixmap_lars;
GtkStyle *style;
GList *dlist_cdrom;
GList *dlist_speed;
GList *dlist_size;
GList *dlist_normalize;

GtkWidget *dialog_button;
GtkWidget *dialog_label;
GtkWidget *dialog_sleep_button;
GtkWidget *dialog_sleep_label;

GtkWidget *box_sandman_full;
GtkWidget *box_sandman_main;
GtkWidget *box_sandman_left;
GtkWidget *box_sandman_buttons;
GtkWidget *box_sandman_right;
GtkWidget *scrolled_lars;
GtkWidget *button_parent_dir;
GtkWidget *button_add;
GtkWidget *button_add_all;
GtkWidget *button_add_break;
GtkWidget *button_remove;
GtkWidget *button_remove_all;
GtkWidget *button_okay;
GtkWidget *scrolled_jamez;

  getcwd(cwdir,1023);

  working=0;

  gtk_init (&argc, &argv);
  window=gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title(GTK_WINDOW(window), "Lars");

  box_right=gtk_vbox_new(FALSE, 0);
  box_left=gtk_vbox_new(FALSE, 0);
  box_main=gtk_hbox_new(FALSE, 0);
  box_full=gtk_vbox_new(FALSE, 0);

  gtk_signal_connect(GTK_OBJECT(window), "delete_event", 
                     GTK_SIGNAL_FUNC (delete_event), NULL);

  gtk_signal_connect(GTK_OBJECT(window), "destroy",
                     GTK_SIGNAL_FUNC (seek_and_destroy), NULL);

  gtk_container_set_border_width (GTK_CONTAINER(window), 5);
  gtk_container_set_border_width (GTK_CONTAINER(box_left), 5);
  gtk_container_set_border_width (GTK_CONTAINER(box_right), 5);
  gtk_container_set_border_width (GTK_CONTAINER(box_full), 5);

  button_lars=gtk_button_new_with_label("Select Files");
  button_jamez=gtk_button_new_with_label("Select Temp Dir");
  button_kirk=gtk_button_new_with_label("Start");
  button_bass_player=gtk_button_new_with_label("Help");
  button_dickheads=gtk_button_new_with_label("Quit");

  gtk_signal_connect(GTK_OBJECT(button_lars), "clicked",
                     GTK_SIGNAL_FUNC(button_lars_pushed), NULL);
  gtk_signal_connect(GTK_OBJECT(button_jamez), "clicked",
                     GTK_SIGNAL_FUNC(button_jamez_pushed), NULL);
  gtk_signal_connect(GTK_OBJECT(button_bass_player), "clicked",
                     GTK_SIGNAL_FUNC(bass_player_pushed), NULL);
  gtk_signal_connect(GTK_OBJECT(button_kirk), "clicked",
                     GTK_SIGNAL_FUNC(kirk_pushed), NULL);
  gtk_signal_connect(GTK_OBJECT(button_dickheads), "clicked",
                     GTK_SIGNAL_FUNC(seek_and_destroy), NULL);

  label_lars=gtk_label_new("MP3 Source Dir");
  label_jamez=gtk_label_new("MP3 Temp Dir");
  label_cdrom=gtk_label_new("CDR/CDRW");
  label_speed=gtk_label_new("Drive Speed");
  label_size=gtk_label_new("CD Size In MB");
  label_normalize=gtk_label_new("Normalize Ouput Volume");

  text_lars=gtk_entry_new_with_max_length(1024);
  text_jamez=gtk_entry_new_with_max_length(1024);
  gtk_entry_set_text((GtkEntry *)text_jamez,TEMPDIR);

  style=gtk_widget_get_style(window);

  colormap=gtk_widget_get_colormap(window);
  pixmap_lars=gdk_pixmap_colormap_create_from_xpm_d(NULL,colormap,&mask,NULL,
                                           (gchar **)lars_xpm);

/*
  pixmap_lars=gdk_pixmap_create_from_xpm_d (window->window, &mask,
				&style->bg[GTK_STATE_NORMAL],
				(gchar **)lars_xpm);
*/
  pixmapwid=gtk_pixmap_new(pixmap_lars, mask);

  status_sad_but_true=gtk_statusbar_new();
  context_id=gtk_statusbar_get_context_id(GTK_STATUSBAR(status_sad_but_true), "Statusbar");
  gtk_statusbar_push(GTK_STATUSBAR(status_sad_but_true),(guint) &context_id, "Copyright 2002-2006 - Michael Kohn / Version: "VERSION);

  dir_lars=gtk_file_selection_new("MP3 Source Dir");
  dir_jamez=gtk_file_selection_new("MP3 Temp");

  gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(dir_lars)->ok_button),
                   "clicked",(GtkSignalFunc) dir_lars_ok, dir_lars);
  gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(dir_lars)->cancel_button),
                   "clicked",(GtkSignalFunc) dir_lars_cancel, dir_lars);

  gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(dir_jamez)->ok_button),
                   "clicked",(GtkSignalFunc) dir_jamez_ok, dir_jamez);
  gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(dir_jamez)->cancel_button),
                   "clicked",(GtkSignalFunc) dir_jamez_cancel, dir_jamez);

  gtk_widget_set_usize(window,396,342);

  combo_cdrom=gtk_combo_new();
  combo_speed=gtk_combo_new();
  combo_size=gtk_combo_new();
  combo_normalize=gtk_combo_new();

  dlist_cdrom=NULL;

  count=0;
  fp=popen("cdrecord -scanbus | grep CD","r");
  while(read_line(fp,temp1)==1)
  {
    battery(temp2,temp1);       
    temp2[30]=0;
    dlist_cdrom=g_list_append(dlist_cdrom,temp2);
    count++;
  }
  fclose(fp);

  if (count==0) dlist_cdrom=g_list_append(dlist_cdrom,"/dev/cdrom");

  gtk_combo_set_popdown_strings((GtkCombo *)combo_cdrom, dlist_cdrom);

  dlist_speed=NULL;
  dlist_speed=g_list_append(dlist_speed,"default");
  dlist_speed=g_list_append(dlist_speed,"1");
  dlist_speed=g_list_append(dlist_speed,"2");
  dlist_speed=g_list_append(dlist_speed,"4");
  dlist_speed=g_list_append(dlist_speed,"6");
  dlist_speed=g_list_append(dlist_speed,"8");
  dlist_speed=g_list_append(dlist_speed,"12");
  dlist_speed=g_list_append(dlist_speed,"16");
  dlist_speed=g_list_append(dlist_speed,"20");
  dlist_speed=g_list_append(dlist_speed,"24");
  gtk_combo_set_popdown_strings((GtkCombo *)combo_speed, dlist_speed);


  dlist_size=NULL;
/*
  dlist_size=g_list_append(dlist_size,"150");
  dlist_size=g_list_append(dlist_size,"180");
*/
  dlist_size=g_list_append(dlist_size,"700");
  dlist_size=g_list_append(dlist_size,"650");
  gtk_combo_set_popdown_strings((GtkCombo *)combo_size, dlist_size);

  dlist_normalize=NULL;
  dlist_normalize=g_list_append(dlist_normalize,"None");
  dlist_normalize=g_list_append(dlist_normalize,"Cleanly");
  dlist_normalize=g_list_append(dlist_normalize,"Loud (Read Docs)");
  gtk_combo_set_popdown_strings((GtkCombo *)combo_normalize, dlist_normalize);

  /* gtk_container_add(GTK_CONTAINER(box_left), pixmapwid); */
  /* gtk_container_add(GTK_CONTAINER(box_left), label_lars); */
  /* gtk_container_add(GTK_CONTAINER(box_left), text_lars); */
  gtk_container_add(GTK_CONTAINER(box_left), label_jamez);
  gtk_container_add(GTK_CONTAINER(box_left), text_jamez);
  gtk_container_add(GTK_CONTAINER(box_left), label_cdrom);
  gtk_container_add(GTK_CONTAINER(box_left), combo_cdrom);
  gtk_container_add(GTK_CONTAINER(box_left), label_speed);
  gtk_container_add(GTK_CONTAINER(box_left), combo_speed);
  gtk_container_add(GTK_CONTAINER(box_left), label_size);
  gtk_container_add(GTK_CONTAINER(box_left), combo_size);
  gtk_container_add(GTK_CONTAINER(box_left), label_normalize);
  gtk_container_add(GTK_CONTAINER(box_left), combo_normalize);
  gtk_container_add(GTK_CONTAINER(box_right), button_lars);
  gtk_container_add(GTK_CONTAINER(box_right), button_jamez);
  gtk_container_add(GTK_CONTAINER(box_right), button_kirk);
  gtk_container_add(GTK_CONTAINER(box_right), button_bass_player);
  gtk_container_add(GTK_CONTAINER(box_right), button_dickheads);
  gtk_container_add(GTK_CONTAINER(box_main), box_left);
  gtk_container_add(GTK_CONTAINER(box_main), box_right);
  gtk_container_add(GTK_CONTAINER(box_full), pixmapwid);
  gtk_container_add(GTK_CONTAINER(box_full), box_main);
  /* gtk_container_add(GTK_CONTAINER(box_full), status_sad_but_true); */

  gtk_box_pack_start(GTK_BOX(box_full),status_sad_but_true,0,0,0);
  gtk_container_add(GTK_CONTAINER(window), box_full);

  gtk_widget_show(button_lars);
  gtk_widget_show(button_jamez);
  gtk_widget_show(button_kirk);
  gtk_widget_show(button_bass_player);
  gtk_widget_show(button_dickheads);
  gtk_widget_show(pixmapwid);
  /* gtk_widget_show(label_lars); */
  /* gtk_widget_show(text_lars); */
  gtk_widget_show(label_jamez);
  gtk_widget_show(text_jamez);
  gtk_widget_show(label_cdrom);
  gtk_widget_show(combo_cdrom);
  gtk_widget_show(label_size);
  gtk_widget_show(combo_size);
  gtk_widget_show(label_speed);
  gtk_widget_show(combo_speed);
  gtk_widget_show(label_normalize);
  gtk_widget_show(combo_normalize);
  gtk_widget_show(status_sad_but_true);
  gtk_widget_show(box_left);
  gtk_widget_show(box_right);
  gtk_widget_show(box_main);
  gtk_widget_show(box_full);
  gtk_widget_show(window);

  dialog_help=gtk_dialog_new();
  dialog_sleep=gtk_dialog_new();

  dialog_button=gtk_button_new_with_label("Close");
  gtk_signal_connect (GTK_OBJECT (dialog_button), "clicked",
                      GTK_SIGNAL_FUNC (bass_player_cancel), NULL);
  dialog_label=gtk_label_new(help_message);

  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog_help)->vbox),dialog_label,
          TRUE,TRUE,0);
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog_help)->action_area),
          dialog_button, TRUE, TRUE, 0);
  gtk_container_border_width (GTK_CONTAINER (dialog_help), 10);
  gtk_widget_show(dialog_label);
  gtk_widget_show(dialog_button);
  gtk_signal_connect(GTK_OBJECT(dialog_help), "delete_event", 
                     GTK_SIGNAL_FUNC (bass_player_cancel), NULL);
  gtk_signal_connect(GTK_OBJECT(dialog_help), "destroy",
                     GTK_SIGNAL_FUNC (bass_player_cancel), NULL);

  dialog_sleep_button=gtk_button_new_with_label("Continue");
  gtk_signal_connect (GTK_OBJECT (dialog_sleep_button), "clicked",
                      GTK_SIGNAL_FUNC (continue_fire), NULL);
  dialog_sleep_label=gtk_label_new(continue_message);
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog_sleep)->vbox),dialog_sleep_label,
          TRUE,TRUE,0);
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog_sleep)->action_area),
          dialog_sleep_button, TRUE, TRUE, 0);

  gtk_container_border_width (GTK_CONTAINER (dialog_sleep), 10);
  gtk_widget_show(dialog_sleep_label);
  gtk_widget_show(dialog_sleep_button);
  gtk_signal_connect(GTK_OBJECT(dialog_sleep), "delete_event", 
                     GTK_SIGNAL_FUNC (continue_fire), NULL);
  gtk_signal_connect(GTK_OBJECT(dialog_sleep), "destroy",
                     GTK_SIGNAL_FUNC (continue_fire), NULL);

  window_sandman=gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title(GTK_WINDOW(window_sandman), "Lars - File Selection");

  gtk_signal_connect(GTK_OBJECT(window_sandman), "delete_event", 
                     GTK_SIGNAL_FUNC (exit_light), NULL);

  gtk_signal_connect(GTK_OBJECT(window_sandman), "destroy",
                     GTK_SIGNAL_FUNC (exit_light), NULL);

  box_sandman_main=gtk_hbox_new(FALSE, 5);
  box_sandman_left=gtk_vbox_new(FALSE, 0);
  /* box_sandman_buttons=gtk_hbox_new(FALSE, 0); */
  box_sandman_buttons=gtk_hbutton_box_new();
  box_sandman_right=gtk_vbox_new(FALSE, 0);
  box_sandman_full=gtk_vbox_new(FALSE, 0);

  /* gtk_box_set_homogeneous(GTK_BOX(box_sandman_buttons),TRUE); */

  scrolled_lars=gtk_scrolled_window_new(NULL,NULL);
  scrolled_jamez=gtk_scrolled_window_new(NULL,NULL);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolled_lars),
                                  GTK_POLICY_AUTOMATIC, GTK_POLICY_ALWAYS);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolled_jamez),
                                  GTK_POLICY_AUTOMATIC, GTK_POLICY_ALWAYS);

  gtk_box_pack_start(GTK_BOX(box_sandman_left), scrolled_lars, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(box_sandman_right), scrolled_jamez, TRUE, TRUE, 0);

  clist_lars=gtk_clist_new(1);
  clist_jamez=gtk_clist_new(2);

  gtk_clist_set_column_width(GTK_CLIST(clist_lars), 0, 600);
  gtk_clist_set_column_width(GTK_CLIST(clist_jamez), 0, 150);
  gtk_clist_set_column_width(GTK_CLIST(clist_jamez), 1, 600);

  gtk_clist_set_shadow_type(GTK_CLIST(clist_lars), GTK_SHADOW_OUT);
  gtk_clist_set_shadow_type(GTK_CLIST(clist_jamez), GTK_SHADOW_OUT);

  button_parent_dir=gtk_button_new_with_label("Parent");
  button_add=gtk_button_new_with_label("Add");
  button_add_all=gtk_button_new_with_label("Add All");
  button_add_break=gtk_button_new_with_label("Add Break");
  button_remove=gtk_button_new_with_label("Remove");
  button_remove_all=gtk_button_new_with_label("Clear");
  button_okay=gtk_button_new_with_label("Done");

  gtk_signal_connect(GTK_OBJECT(button_parent_dir), "clicked",
                     GTK_SIGNAL_FUNC(dear_mother_dear_father), NULL);
  gtk_signal_connect(GTK_OBJECT(button_add_all), "clicked",
                     GTK_SIGNAL_FUNC(whiplash), NULL);
  gtk_signal_connect(GTK_OBJECT(button_add_break), "clicked",
                     GTK_SIGNAL_FUNC(frayed_ends), NULL);
  gtk_signal_connect(GTK_OBJECT(button_okay), "clicked",
                     GTK_SIGNAL_FUNC(exit_light), NULL);
  gtk_signal_connect(GTK_OBJECT(button_remove_all), "clicked",
                     GTK_SIGNAL_FUNC(fade_to_black), NULL);

  gtk_box_set_homogeneous(GTK_BOX(box_sandman_full),FALSE);

  gtk_widget_set_usize(window_sandman,500,342);

  gtk_clist_set_column_title(GTK_CLIST(clist_lars),0,(gchar *)"Source File");
  gtk_clist_set_column_title(GTK_CLIST(clist_jamez),0,(gchar *)"Selected Files");
  gtk_clist_set_column_title(GTK_CLIST(clist_jamez),1,(gchar *)"Path");

  gtk_clist_column_titles_show(GTK_CLIST(clist_lars));
  gtk_clist_column_titles_show(GTK_CLIST(clist_jamez));

  gtk_signal_connect(GTK_OBJECT(clist_lars), "select_row",
                     GTK_SIGNAL_FUNC(the_bell_tolls), NULL);
  gtk_signal_connect(GTK_OBJECT(clist_jamez), "select_row",
                     GTK_SIGNAL_FUNC(to_die), NULL);

  status_sandman=gtk_statusbar_new();
  context_id_sandman=gtk_statusbar_get_context_id(GTK_STATUSBAR(status_sandman), "Statusbar");
  gtk_statusbar_push(GTK_STATUSBAR(status_sandman),(guint) &context_id_sandman, cwdir);
  gtk_container_set_border_width (GTK_CONTAINER(box_sandman_full), 5);

  gtk_container_add(GTK_CONTAINER(box_sandman_buttons),button_parent_dir);
  gtk_container_add(GTK_CONTAINER(box_sandman_buttons),button_add_all);
  gtk_container_add(GTK_CONTAINER(box_sandman_buttons),button_add_break);
  gtk_container_add(GTK_CONTAINER(box_sandman_buttons),button_remove_all);
  gtk_container_add(GTK_CONTAINER(box_sandman_buttons),button_okay);

/*
  gtk_box_pack_start(GTK_BOX(box_sandman_left),scrolled_lars,TRUE,TRUE,0);
  gtk_box_pack_start(GTK_BOX(box_sandman_right),scrolled_jamez,TRUE,TRUE,0);
*/

  gtk_container_add(GTK_CONTAINER(scrolled_lars),clist_lars);
  gtk_container_add(GTK_CONTAINER(scrolled_jamez),clist_jamez);

  gtk_container_add(GTK_CONTAINER(box_sandman_main),box_sandman_left);
  gtk_container_add(GTK_CONTAINER(box_sandman_main),box_sandman_right);

/*
  gtk_container_add(GTK_CONTAINER(box_sandman_full),box_sandman_buttons);
  gtk_container_add(GTK_CONTAINER(box_sandman_full),status_sandman);
  gtk_widget_set_usize(box_sandman_full,500,300);
  gtk_box_pack_start(box_sandman_full,box_sandman_main,0,0,0);
*/
  gtk_box_pack_start(GTK_BOX(box_sandman_full),status_sandman,0,0,0);
  gtk_container_add(GTK_CONTAINER(box_sandman_full),box_sandman_main);
  gtk_box_pack_start(GTK_BOX(box_sandman_full),box_sandman_buttons,0,0,0);
  gtk_container_add(GTK_CONTAINER(window_sandman),box_sandman_full);


  gtk_widget_show(box_sandman_right);
  gtk_widget_show(scrolled_lars);
  gtk_widget_show(clist_lars);
  gtk_widget_show(button_parent_dir);
  gtk_widget_show(button_add);
  gtk_widget_show(button_add_all);
  gtk_widget_show(button_add_break);
  gtk_widget_show(button_remove);
  gtk_widget_show(button_remove_all);
  gtk_widget_show(button_okay);
  gtk_widget_show(scrolled_jamez);
  gtk_widget_show(clist_jamez);
  gtk_widget_show(box_sandman_main);
  gtk_widget_show(box_sandman_left);
  gtk_widget_show(box_sandman_buttons);
  gtk_widget_show(box_sandman_full);
  gtk_widget_show(status_sandman);
  // gtk_widget_show(window_sandman);

  gtk_main();

  return(0);
}



